#!/bin/sh -e

# Copyright 2023 Dima Krasner
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# 	http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cat << EOF > migrations.go
package migrations

// auto-generated by list.sh

var migrations = []migration{
EOF

ls [0-9][0-9][0-9]_*.go | sort -n | while read f; do
	id=${f%.go}
	id=${id#*_}
	echo "	{\"$id\", $id}," >> migrations.go
done

echo "}" >> migrations.go
